/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#ifndef _BITSTREAM_H_
#define _BITSTREAM_H_

class cBitStream
{
private:
	bool copied;
protected:
	unsigned char * data;
	int length;
	int bytePos;
	int bitPos;
public:
	cBitStream(unsigned char * data, int length, bool copy = false);
	~cBitStream();
	unsigned char * Data() { return data; }
	unsigned char * CurrentData() { return &data[bytePos]; }
	int Length() { return length; }
	int BytePosition() { return bytePos; }
	int BitPosition() { return bitPos; }
	bool End() { return bytePos == length; }

	void ByteAlign();
	void SeekStart();
	void SeekBits(int bits);
	void SeekBytes(int bytes);
	unsigned int NextBits(int bits);
	unsigned int GetBits(int bits);
	unsigned int GetBit();
};

#endif
