/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#pragma once

#include <string>

#include "GameServer.h"

const long kConditionTypeIP			= 1;
const long kConditionTypePort			= 2;
const long kConditionTypeHostname		= 3;
const long kConditionTypeGame			= 4;
const long kConditionTypeGamedir		= 5;
const long kConditionTypeGametype		= 6;
const long kConditionTypeMap			= 7;
const long kConditionTypeCntPlayers	= 8;
const long kConditionTypePlayer		= 9;
const long kConditionTypeCustomLong	= 10;
const long kConditionTypeCustomFloat	= 11;
const long kConditionTypeCustomString	= 12;

const long kConditionDataTypeLong		= 1;
const long kConditionDataTypeFloat		= 2;
const long kConditionDataTypeString	= 3;

const long kConditionOpEqual	= 0;
const long kConditionOpLower	= 1;
const long kConditionOpGreater	= 2;
const long kConditionOpContain	= 3;
const long kConditionOpNot		= 256;

class Condition
{
public:
	Condition(long type);
	void SetValue(unsigned long value, long operation);
	void SetValue(double value, long operation);
	void SetValue(string value, long operation);
	bool Check(GameServer *server);
private:
	long fType;
	long fDataType;
	long fOperation;
	unsigned long fLongValue;
	double fFloatValue;
	string fStringValue;
};
