/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "DlgAbout.h"
#include "QFinder.h"

DlgAbout *gDlgAbout;

INT_PTR CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

DlgAbout::DlgAbout(HWND hParent)
{
	gDlgAbout = this;
	fParent = hParent;
}

DlgAbout::~DlgAbout()
{
}

void DlgAbout::Create()
{
	DialogBox(gQFinder->fInstance, MAKEINTRESOURCE(IDD_ABOUT), fParent, (DLGPROC) AboutDialogProc);
}

INT_PTR DlgAbout::DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		OnInitDialog(hDlg);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			EndDialog(hDlg, wParam);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

void DlgAbout::OnInitDialog(HWND hDlg)
{
	fWnd = hDlg;
	fVersion.Get(hDlg, IDC_VERSION);
	fCopyright.Get(hDlg, IDC_COPYRIGHT);
	fEmail.Get(hDlg, IDC_EMAIL);
	fHomepage.Get(hDlg, IDC_HOMEPAGE);
	fThanks.Get(hDlg, IDC_THANKS);
	fVersion.SetText(gQFinder->fAppName + " " + gQFinder->fVersion);
	fCopyright.SetText("Copyright (c) 1999, 2004 Andreas 'powARman' Regel");
	fEmail.SetText("E-mail: andreas.regel@powarman.de");
	fHomepage.SetText("Homepage: www.powarman.de");
	fThanks.SetText("Thanks go to Crusader and Nokx for beta-testing and intensive bug-hunting");
}

INT_PTR CALLBACK AboutDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return gDlgAbout->DialogProc(hDlg, message, wParam, lParam);
}
