/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "DlgNetwork.h"
#include "DlgNetworkFrame.h"
#include "QFinder.h"

DlgNetworkFrame::DlgNetworkFrame(DlgNetwork *dlg, long frameID)
{
	fDlg = dlg;
	fFrameID = frameID;
}

DlgNetworkFrame::~DlgNetworkFrame()
{
	DestroyWindow (fFrame);
}

void DlgNetworkFrame::Create(DLGPROC dlgProc)
{
	HRSRC hrsrc = FindResource(NULL, MAKEINTRESOURCE (fFrameID), RT_DIALOG);
	HGLOBAL hglb = LoadResource(gQFinder->fInstance, hrsrc);
	DLGTEMPLATE *dlgTemplate = (DLGTEMPLATE *) LockResource(hglb);
	fFrame = CreateDialogIndirect(gQFinder->fInstance, dlgTemplate, fDlg->fWnd, dlgProc);
}

void DlgNetworkFrame::Show()
{
	ShowWindow(fFrame, SW_SHOW);
}

void DlgNetworkFrame::Hide()
{
	ShowWindow(fFrame, SW_HIDE);
}
