/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#ifndef _DLGNETWORKGAME_H_
#define _DLGNETWORKGAME_H_

#include "DlgNetworkFrame.h"
#include "GameServer.h"

#include "EditControl.h"
#include "IPAddressControl.h"
#include "ListBox.h"
#include "ListView.h"
#include "UpDownControl.h"

class DlgNetworkGame : public DlgNetworkFrame
{
public:
	DlgNetworkGame(DlgNetwork *dlg, long frameID);
	~DlgNetworkGame();
	void Create();
	void Show(long game);
	INT_PTR DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
private:
	void AddServer(GameServer *server);
	LRESULT OnNotify(WPARAM wParam, LPARAM lParam);
	LRESULT OnCommand(WPARAM wParam, LPARAM lParam);

	long fGame;

	EditControl fBCPort;
	UpDownControl fBCPortUpDown;
	ListBox fBCPortList;
	IPAddressControl fIPAddress;
	UpDownControl fPortUpDown;
	EditControl fPort;
	EditControl fDescription;
	ListView fList;
};

extern DlgNetworkGame *gDlgNetworkGame;

#endif //_DLGNETWORKGAME_H_