/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "DlgNetwork.h"
#include "DlgNetworkGeneral.h"
#include "QFinder.h"

DlgNetworkGeneral *gDlgNetworkGeneral;

INT_PTR CALLBACK NetworkGeneralDialogProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

DlgNetworkGeneral::DlgNetworkGeneral(DlgNetwork *dlg, long frameID)
:DlgNetworkFrame(dlg, frameID)
{
}

DlgNetworkGeneral::~DlgNetworkGeneral()
{
	DlgNetworkFrame::~DlgNetworkFrame();
}

void DlgNetworkGeneral::Create()
{
	DlgNetworkFrame::Create((DLGPROC) NetworkGeneralDialogProc);
}

INT_PTR DlgNetworkGeneral::DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		SetWindowPos(hDlg, HWND_TOP, 170, 32, 0, 0, SWP_NOSIZE);
		return TRUE;
	case WM_SHOWWINDOW:
		if (wParam)
		{
			// is shown
		}
		break;
	case WM_COMMAND:
		switch (HIWORD(wParam))
		{
		case BN_CLICKED:
			switch (LOWORD(wParam))
			{
			case 0:;
			}
			break;
		}
		break;
	}
	return FALSE;
}


INT_PTR CALLBACK NetworkGeneralDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return gDlgNetworkGeneral->DialogProc(hDlg, message, wParam, lParam);
}
