/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "DlgPassword.h"
#include "QFinder.h"

DlgPassword *gDlgPassword;

INT_PTR CALLBACK PasswordDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

DlgPassword::DlgPassword(HWND hParent)
{
	gDlgPassword = this;
	fParent = hParent;
}

DlgPassword::~DlgPassword()
{
}

INT_PTR DlgPassword::Create(string *pass)
{
	fPassString = pass;
	return DialogBox(gQFinder->fInstance, MAKEINTRESOURCE(IDD_PASSWORD), fParent, (DLGPROC) PasswordDialogProc);
}

INT_PTR DlgPassword::DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		OnInitDialog(hDlg);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			*fPassString = fPassword.GetText();
		case IDCANCEL:
			EndDialog(hDlg, wParam);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

void DlgPassword::OnInitDialog(HWND hDlg)
{
	fWnd = hDlg;
	fPassword.Get(hDlg, IDC_PASSWORD);
	fPassword.SetTextLimit(60);
}

INT_PTR CALLBACK PasswordDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return gDlgPassword->DialogProc(hDlg, message, wParam, lParam);
}
