/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "DlgPreferences.h"
#include "DlgPreferencesAppearance.h"
#include "QFinder.h"

DlgPreferencesAppearance *gDlgPreferencesAppearance;

INT_PTR CALLBACK PreferencesAppearanceDialogProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

DlgPreferencesAppearance::DlgPreferencesAppearance(DlgPreferences *dlg, long frameID)
:DlgPreferencesFrame(dlg, frameID)
{
}

DlgPreferencesAppearance::~DlgPreferencesAppearance()
{
	DlgPreferencesFrame::~DlgPreferencesFrame();
}

void DlgPreferencesAppearance::Create()
{
	DlgPreferencesFrame::Create((DLGPROC) PreferencesAppearanceDialogProc);
}

INT_PTR DlgPreferencesAppearance::DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		SetWindowPos(hDlg, HWND_TOP, 226, 32, 0, 0, SWP_NOSIZE);
		return TRUE;
	case WM_SHOWWINDOW:
		if (wParam)
		{
			// is shown
			if (fDlg->fSettings.fMainWindow.fMinimizeMode == kMinimizeModeNormal)
				CheckRadioButton(fFrame, IDC_MINIMIZENORMAL, IDC_MINIMIZESYSTEM, IDC_MINIMIZENORMAL);
			else if (fDlg->fSettings.fMainWindow.fMinimizeMode == kMinimizeModeTray)
				CheckRadioButton(fFrame, IDC_MINIMIZENORMAL, IDC_MINIMIZESYSTEM, IDC_MINIMIZESYSTEM);

			if (fDlg->fSettings.fMainWindow.fToolBarTextMode == kToolBarTextNone)
				CheckRadioButton(fFrame, IDC_TOOLBARTEXTNONE, IDC_TOOLBARTEXTNEXT, IDC_TOOLBARTEXTNONE);
			else if (fDlg->fSettings.fMainWindow.fToolBarTextMode == kToolBarTextBelow)
				CheckRadioButton(fFrame, IDC_TOOLBARTEXTNONE, IDC_TOOLBARTEXTNEXT, IDC_TOOLBARTEXTBELOW);
			else if (fDlg->fSettings.fMainWindow.fToolBarTextMode == kToolBarTextRight)
				CheckRadioButton(fFrame, IDC_TOOLBARTEXTNONE, IDC_TOOLBARTEXTNEXT, IDC_TOOLBARTEXTNEXT);
		}
		else
		{
			if (IsDlgButtonChecked(fFrame, IDC_MINIMIZENORMAL) == BST_CHECKED)
				fDlg->fSettings.fMainWindow.fMinimizeMode = kMinimizeModeNormal;
			if (IsDlgButtonChecked(fFrame, IDC_MINIMIZESYSTEM) == BST_CHECKED)
				fDlg->fSettings.fMainWindow.fMinimizeMode = kMinimizeModeTray;

			if (IsDlgButtonChecked(fFrame, IDC_TOOLBARTEXTNONE) == BST_CHECKED)
				fDlg->fSettings.fMainWindow.fToolBarTextMode = kToolBarTextNone;
			if (IsDlgButtonChecked(fFrame, IDC_TOOLBARTEXTBELOW) == BST_CHECKED)
				fDlg->fSettings.fMainWindow.fToolBarTextMode = kToolBarTextBelow;
			if (IsDlgButtonChecked(fFrame, IDC_TOOLBARTEXTNEXT) == BST_CHECKED)
				fDlg->fSettings.fMainWindow.fToolBarTextMode = kToolBarTextRight;
		}
		break;
	case WM_COMMAND:
		switch (HIWORD(wParam))
		{
		case BN_CLICKED:
			switch (LOWORD(wParam))
			{
			case 0:;
			}
			break;
		}
		break;
	}
	return FALSE;
}


INT_PTR CALLBACK PreferencesAppearanceDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return gDlgPreferencesAppearance->DialogProc(hDlg, message, wParam, lParam);
}
