/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "DlgPreferences.h"
#include "DlgPreferencesFrame.h"
#include "QFinder.h"

DlgPreferencesFrame::DlgPreferencesFrame(DlgPreferences *dlg, long frameID)
{
	fDlg = dlg;
	fFrameID = frameID;
}

DlgPreferencesFrame::~DlgPreferencesFrame()
{
	DestroyWindow (fFrame);
}

void DlgPreferencesFrame::Create(DLGPROC dlgProc)
{
    HRSRC hrsrc = FindResource(NULL, MAKEINTRESOURCE (fFrameID), RT_DIALOG);
    HGLOBAL hglb = LoadResource(gQFinder->fInstance, hrsrc);
    DLGTEMPLATE *dlgTemplate = (DLGTEMPLATE *) LockResource(hglb);
	fFrame = CreateDialogIndirect(gQFinder->fInstance, dlgTemplate, fDlg->fWnd, dlgProc);
}

void DlgPreferencesFrame::Show()
{
	ShowWindow(fFrame, SW_SHOW);
}

void DlgPreferencesFrame::Hide()
{
	ShowWindow(fFrame, SW_HIDE);
}
