/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "Filter.h"

Filter::Filter(string name)
:	fActive(true),
	fName(name)
{
}

void Filter::SetActive(bool active)
{
	fActive = active;
}

void Filter::AddCondition(Condition & condition)
{
	fConditions.push_back(condition);
}

void Filter::RemoveCondition(unsigned int num)
{
	if (num < fConditions.size())
		fConditions.erase(fConditions.begin() + num);
}

Condition * Filter::GetCondition(unsigned int num)
{
	vector <Condition>::iterator it;
	if (num < fConditions.size())
	{
		it = fConditions.begin() + num;
		return it.operator ->();
	}
	return NULL;
}

unsigned int Filter::ConditionCount()
{
	return fConditions.size();
}

bool Filter::Check(GameServer *server)
{
	if (!fActive)
		return false;

	vector <Condition>::iterator it;
	for (it = fConditions.begin(); it != fConditions.end(); it++)
		if (it->Check(server) == false)
			return false;
	return true;
}
