/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#pragma once

#include <string>
#include <vector>

#include "GameServer.h"
#include "Condition.h"

class Filter
{
public:
	Filter(string name);
	void SetActive(bool active);
	void AddCondition(Condition & condition);
	void RemoveCondition(unsigned int num);
	Condition * GetCondition(unsigned int num);
	unsigned int ConditionCount();
	bool Check(GameServer *server);
private:
	bool fActive;
	string fName;
	vector <Condition> fConditions;
};
