/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#ifndef _GAME_H_
#define _GAME_H_

static const long kGameCount = 25;

static const long kGameAll  = 0;
static const long kGameQW   = 1;
static const long kGameQ2   = 2;
static const long kGameQ3   = 3;
static const long kGameHL   = 4;
static const long kGameUT   = 5;
static const long kGameUT23 = 6;
static const long kGameSOF  = 7;
static const long kGameSOF2 = 8;
static const long kGameTBS  = 9;
static const long kGameTBS2 = 10;
static const long kGameEF   = 11;
static const long kGameFK2  = 12;
static const long kGameRTCW = 13;
static const long kGameJK2  = 14;
static const long kGameBF42 = 15;
static const long kGameMOHA = 16;
static const long kGameMOHS = 17;
static const long kGameMOHB = 18;
static const long kGameEF2  = 19;
static const long kGameJK3  = 20;
static const long kGameCOD  = 21;
static const long kGameET   = 22;
static const long kGameBFVN = 23;
static const long kGameUT24 = 24;
static const long kGameFCRY = 25;

static const long kGameSortAlph[kGameCount + 1] = {
	0,
	kGameBF42,
	kGameBFVN,
	kGameCOD,
	kGameFCRY,
	kGameFK2,
	kGameHL,
	kGameJK2,
	kGameJK3,
	kGameMOHA,
	kGameMOHB,
	kGameMOHS,
	kGameQW,
	kGameQ2,
	kGameQ3,
	kGameRTCW,
	kGameSOF,
	kGameSOF2,
	kGameEF,
	kGameEF2,
	kGameTBS,
	kGameTBS2,
	kGameUT,
	kGameUT23,
	kGameUT24,
	kGameET
};

class Game
{
public:
	Game(long game);
	~Game();

	string fTitle;
	string fID;
	string fStdExe;
	string fConnect;
	string fGameDir;
	string fPassword;
	long fQueryCnt;
	vector <string> fQueryStrings;
	unsigned short fStdPort;
	HTREEITEM fTreeItem;
};

extern vector <Game> gGames;

#endif //_GAME_H_
