/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#ifndef _GAMESERVER_H_
#define _GAMESERVER_H_

#include "BaseServer.h"
#include "Player.h"
#include "StringVariable.h"

static const kGameServerMaxMiss = 3;

class GameServer : public BaseServer
{
public:
	GameServer();
	GameServer(unsigned long ip, unsigned short port);
	GameServer(unsigned long ip, unsigned short port, unsigned short queryPort);
	void SetAddress(unsigned long ip, unsigned short port);
	void SetAddress(unsigned long ip, unsigned short port, unsigned short queryPort);
	void SetVariable(StringVariable &variable);
	StringVariable *GetVariable(string name);
	bool fFound;
	long fListID;
	long fMissedCount;
	long fGame;
	long fPing;
	unsigned short fQueryPort;
	string fQueryPortStr;
	string fHostName;
	string fGameDir;
	string fMapName;
	string fDescription;
	long fGameType;
	string fGameTypeStr;
	unsigned long fDMFlags;
	long fMaxPlayers;
	long fCntPlayers;
	bool fNeedPass;
	bool fGotPacket[5];
	vector<Player> fPlayers;
	list<StringVariable> fVariables;

	friend bool operator< (const GameServer &x, const GameServer &y)
	{
		return ((x.fGame < y.fGame) || 
				(x.fGame == y.fGame && x.fIP < y.fIP) ||
				(x.fGame == y.fGame && x.fIP == y.fIP && x.fPort < y.fPort));
	}
};

#endif //_GAMESERVER_H_
