/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "LogFile.h"
#include "QFinder.h"
#include <time.h>

LogFile::LogFile(string workingDir, int logLevel)
:	level(logLevel)
{
	fileName = workingDir + "\\QFinder.log";
}

void LogFile::ErrorMessage(string message)
{
	if (level < 1)
		return;
	file.open(fileName.c_str(), ios_base::out | ios_base::app);
	if (file.is_open())
	{
		time_t t;
		time(&t);
		string str = ctime(&t);
		str.resize(str.length() - 1);
		file << str << " error: " << message << endl;
		file.close();
	}
}

void LogFile::InfoMessage(string message)
{
	if (level < 2)
		return;
	file.open(fileName.c_str(), ios_base::out | ios_base::app);
	if (file.is_open())
	{
		time_t t;
		time(&t);
		string str = ctime(&t);
		str.resize(str.length() - 1);
		file << str << " info: " << message << endl;
		file.close();
	}
}

void LogFile::DebugMessage(string message)
{
	if (level < 3)
		return;
	file.open(fileName.c_str(), ios_base::out | ios_base::app);
	if (file.is_open())
	{
		time_t t;
		time(&t);
		string str = ctime(&t);
		str.resize(str.length() - 1);
		file << str << " debug: " << message << endl;
		file.close();
	}
}

LogFile *gLogFile;