/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "MainToolBar.h"
#include "QFinder.h"
#include "Game.h"

MainToolBar::MainToolBar()
: ToolBar()
{
}

MainToolBar::~MainToolBar()
{
}

void MainToolBar::Create(HWND hParent)
{
    if (gQFinder->fSettings.fMainWindow.fToolBarTextMode == kToolBarTextRight)
		ToolBar::Create(hParent, IDC_GAME_TREEVIEW, TBSTYLE_LIST);
	else
		ToolBar::Create(hParent, IDC_GAME_TREEVIEW);
	fImageList = ImageList_LoadImage(gQFinder->fInstance, MAKEINTRESOURCE (IDB_MAINTOOLBAR_16M), 32, 0, CLR_DEFAULT, IMAGE_BITMAP, LR_CREATEDIBSECTION);
	SetImageList(fImageList);

    if (gQFinder->fSettings.fMainWindow.fToolBarTextMode == kToolBarTextNone)
	{
		AddButton(0, ID_ACTIONS_JOINGAME, "");
		AddSeparator();
		AddButton(1, ID_ACTIONS_UPDATEALLGAMES, "");
		AddButton(kToolBarIndexRefreshGame, ID_ACTIONS_UPDATESELECTEDGAME, "");
		AddButton(kToolBarIndexRefreshGame + kGameCount + 1, ID_ACTIONS_UPDATESINGLESERVER, "");
	}
	else
	{
		AddButton(0, ID_ACTIONS_JOINGAME, "Join Game");
		AddSeparator();
		AddButton(1, ID_ACTIONS_UPDATEALLGAMES, "Update All");
		AddButton(kToolBarIndexRefreshGame, ID_ACTIONS_UPDATESELECTEDGAME, "Update Game");
		AddButton(kToolBarIndexRefreshGame + kGameCount + 1, ID_ACTIONS_UPDATESINGLESERVER, "Update Server");
	}
}

void MainToolBar::Rebuild()
{
	HWND hParent = fParent;
	vector<bool> buttons;

	buttons.push_back(0 != Message(TB_ISBUTTONENABLED, ID_ACTIONS_JOINGAME, 0));
	buttons.push_back(0 != Message(TB_ISBUTTONENABLED, ID_ACTIONS_UPDATEALLGAMES, 0));
	buttons.push_back(0 != Message(TB_ISBUTTONENABLED, ID_ACTIONS_UPDATESELECTEDGAME, 0));
	buttons.push_back(0 != Message(TB_ISBUTTONENABLED, ID_ACTIONS_UPDATESINGLESERVER, 0));
	DestroyWindow(fHandle);
	Create(hParent);
	EnableButton(ID_ACTIONS_JOINGAME, buttons[0]);
	EnableButton(ID_ACTIONS_UPDATEALLGAMES, buttons[1]);
	EnableButton(ID_ACTIONS_UPDATESELECTEDGAME, buttons[2]);
	EnableButton(ID_ACTIONS_UPDATESINGLESERVER, buttons[3]);
}
