/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "Notifications.h"

Notifications::Notifications(void)
:	fActive(true),
	fType(kNotificationTypeBeep)
{
}

void Notifications::SetActive(bool active)
{
	fActive = active;
}

void Notifications::SetType(long type)
{
	if (type >= 0 && type <= kNotificationTypeBlink)
		fType = type;
}

void Notifications::AddFilter(Filter & filter)
{
	fFilters.push_back(filter);
}

void Notifications::RemoveFilter(unsigned int num)
{
	if (num < fFilters.size())
		fFilters.erase(fFilters.begin() + num);
}

Filter * Notifications::GetFilter(unsigned int num)
{
	vector <Filter>::iterator it;
	if (num < fFilters.size())
	{
		it = fFilters.begin() + num;
		return it.operator ->();
	}
	return NULL;
}

unsigned int Notifications::FilterCount()
{
	return fFilters.size();
}

bool Notifications::Check(GameServer *server)
{
	if (!fActive)
		return false;

	vector <Filter>::iterator it;
	for (it = fFilters.begin(); it != fFilters.end(); it++)
		if (it->Check(server) == true)
			return true;
	return false;
}
