/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#pragma once

#include "Filter.h"

const long kNotificationTypeBeep	= 1;
const long kNotificationTypeBlink	= 2;

class Notifications
{
public:
	Notifications(void);
	void SetActive(bool active);
	void SetType(long type);
	void AddFilter(Filter & filter);
	void RemoveFilter(unsigned int num);
	Filter * GetFilter(unsigned int num);
	unsigned int FilterCount();
	bool Check(GameServer *server);
private:
	bool fActive;
	long fType;
	vector <Filter> fFilters;
};
