/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#ifndef _QFINDER_H_
#define _QFINDER_H_

#include "Settings.h"
#include "ServerList.h"
#include "BCPort.h"

#include <set>

class QFinder
{
public:
	QFinder(HINSTANCE hInstance);
	~QFinder();
	void Init();
	int Run();
	ServerList *GetServerList(long listID);

	string fAppName;
	string fVersion;
	string fWorkingDir;
	HINSTANCE fInstance;
	HICON fIcon;
	Settings fSettings;
	set<ServerList> fServerLists;
	set<BCPort> fBCPorts;
	long fBroadcastID;
	SOCKET fBCSocket;
	long fFavoritesID;
};

extern QFinder *gQFinder;

#endif //_QFINDER_H_