/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "Stdafx.h"
#include "RefreshServer.h"
#include "Utilities.h"
#include "Game.h"

RefreshServer::RefreshServer(unsigned long ip, unsigned short port)
:BaseServer(ip, port)
{
	fQueryPort = port;
	fQueryPortStr = Port2String(port);
	fPacketCount = 0;
	for (int i = 0; i < 10; i++)
		fGotPacket[i] = false;
	fNew = false;
	fTimeoutCount = 0;
	fTryCount = 0;
}

RefreshServer::RefreshServer(unsigned long ip, unsigned short port, unsigned short queryPort)
:BaseServer(ip, port)
{
	fQueryPort = queryPort;
	fQueryPortStr = Port2String(queryPort);
	fPacketCount = 0;
	for (int i = 0; i < 10; i++)
		fGotPacket[i] = false;
	fNew = false;
	fTimeoutCount = 0;
	fTryCount = 0;
}

RefreshServer::RefreshServer(GameServer *server)
{
	SetAddress(server->fIP, server->fPort, server->fQueryPort);
	fGame = server->fGame;
	fPacketCount = gGames[fGame].fQueryCnt;
	for (int i = 0; i < fPacketCount; i++)
	{
		fGotPacket[i] = server->fGotPacket[i];
	}
	fNew = false;
	fTimeoutCount = 0;
	fTryCount = 0;
}

void RefreshServer::SetAddress(unsigned long ip, unsigned short port)
{
	BaseServer::SetAddress(ip, port);
	this->fQueryPort = port;
	this->fQueryPortStr = Port2String(port);
}

void RefreshServer::SetAddress(unsigned long ip, unsigned short port, unsigned short queryPort)
{
	BaseServer::SetAddress(ip, port);
	this->fQueryPort = queryPort;
	this->fQueryPortStr = Port2String(queryPort);
}
