/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#ifndef _SERVERLIST_H_
#define _SERVERLIST_H_

#include <set>

#include "GameServer.h"
#include "MasterServer.h"

const long kServerListTypeBroadcast = 0;
const long kServerListTypeFavorites = 1;
const long kServerListTypeSimple = 2;
const long kServerListTypeMaster = 3;

class ServerList
{
public:
	ServerList(long type, string name);
	~ServerList();
	GameServer *FindServer(long game, unsigned long ip, unsigned short port, long number = 0);
	GameServer *FindServerQuery(long game, unsigned long ip, unsigned short queryPort, long number = 0);
	void LoadFromFile();
	void SaveToFile();
	friend bool operator< (const ServerList &x, const ServerList &y)
	{
		return (x.fName < y.fName);
	}
public:
	static long fCount;
	string fName;
	long fType;
	long fID;
	SOCKET fSocket;
	string fDescription;
	bool fHasChanged;
	MasterServer fMaster;
	MasterServer fProxy;
	set<GameServer> fServers;
private:
	void LoadFavorites();
	void SaveFavorites();
};

#endif //_SERVERLIST_H_