/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#include "StdAfx.h"
#include "Settings.h"

void Settings::Init()
{
	fRegVersion = 2;

	fMainWindow.fMode = kWindowModeNormal;
	fMainWindow.fLeft = 20;
	fMainWindow.fTop = 20;
	fMainWindow.fWidth = 600;
	fMainWindow.fHeight = 440;
	fMainWindow.fTVWidth = 160;
	fMainWindow.fLVHeight = 200;
	fMainWindow.fLVWidth = 250;
	fMainWindow.fMinimizeMode = kMinimizeModeNormal;
	fMainWindow.fToolBarTextMode = kToolBarTextBelow;
	fMainWindow.fLayout = kLayout_Standard;
	fMainWindow.fLayoutParameter1 = kLayout_TreeViewLong;
	fMainWindow.fLayoutParameter2 = kLayout_PlayerLeft;

	COLUMNINFO col;
	col.fSaveToRegistry = 5;

	// ServerListView Columns
	col.fVisible = true;
	col.fPosition = 0;
	col.fWidth = 150;
	col.fSort = kColumnSortAscending;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Hostname";
	col.fID = "SL_Hostname";
	fMainWindow.fServerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 1;
	col.fWidth = 40;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Ping";
	col.fID = "SL_Ping";
	fMainWindow.fServerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 2;
	col.fWidth = 50;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Players";
	col.fID = "SL_Players";
	fMainWindow.fServerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 3;
	col.fWidth = 70;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Map";
	col.fID = "SL_Map";
	fMainWindow.fServerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 4;
	col.fWidth = 70;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Gamedir";
	col.fID = "SL_Gamedir";
	fMainWindow.fServerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 5;
	col.fWidth = 70;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Gametype";
	col.fID = "SL_Gametype";
	fMainWindow.fServerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 6;
	col.fWidth = 100;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "IP";
	col.fID = "SL_IP";
	fMainWindow.fServerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 7;
	col.fWidth = 50;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Port";
	col.fID = "SL_Port";
	fMainWindow.fServerColumns.push_back(col);

	// PlayerListView Columns
	col.fVisible = true;
	col.fPosition = 0;
	col.fWidth = 150;
	col.fSort = kColumnSortAscending;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Player Name";
	col.fID = "PL_PlayerName";
	fMainWindow.fPlayerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 1;
	col.fWidth = 50;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Score";
	col.fID = "PL_Frags";
	fMainWindow.fPlayerColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 2;
	col.fWidth = 50;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Ping";
	col.fID = "PL_Ping";
	fMainWindow.fPlayerColumns.push_back(col);

	// VariableListView Columns
	col.fVisible = true;
	col.fPosition = 0;
	col.fWidth = 100;
	col.fSort = kColumnSortAscending;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Variable";
	col.fID = "VL_Variable";
	fMainWindow.fVariableColumns.push_back(col);

	col.fVisible = true;
	col.fPosition = 1;
	col.fWidth = 100;
	col.fSort = kColumnSortNone;
	col.fFormat = LVCFMT_LEFT;
	col.fTitle = "Value";
	col.fID = "VL_Value";
	fMainWindow.fVariableColumns.push_back(col);

	int i;
	GAMEINFO gameInfo;

	fGame.fStandard = gGames[kGameAll].fID;
	fGame.fLastSelected = gGames[kGameAll].fID;
	for (i = 0; i <= kGameCount; i++)
	{
		gameInfo.fVisible = true;
		gameInfo.fPosition = i;
		gameInfo.fExe = gGames[i].fStdExe;
		gameInfo.fPath = "";
		gameInfo.fParameters = "";
		gameInfo.fSaveToRegistry = 2;
		fGame.fInfos.push_back(gameInfo);
	}
	fGame.fGameSort[1] = kGameQW;
	fGame.fGameSort[2] = kGameQ2;
	fGame.fGameSort[3] = kGameQ3;
	fGame.fGameSort[4] = kGameHL;
	fGame.fGameSort[5] = kGameUT;
	fGame.fGameSort[6] = kGameUT23;
	fGame.fGameSort[7] = kGameUT24;
	fGame.fGameSort[8] = kGameTBS;
	fGame.fGameSort[9] = kGameTBS2;
	fGame.fGameSort[10] = kGameSOF;
	fGame.fGameSort[11] = kGameSOF2;
	fGame.fGameSort[12] = kGameEF;
	fGame.fGameSort[13] = kGameEF;
	fGame.fGameSort[14] = kGameFK2;
	fGame.fGameSort[15] = kGameRTCW;
	fGame.fGameSort[16] = kGameET;
	fGame.fGameSort[17] = kGameJK2;
	fGame.fGameSort[18] = kGameJK3;
	fGame.fGameSort[19] = kGameBF42;
	fGame.fGameSort[20] = kGameBFVN;
	fGame.fGameSort[21] = kGameMOHA;
	fGame.fGameSort[22] = kGameMOHB;
	fGame.fGameSort[23] = kGameMOHS;
	fGame.fGameSort[24] = kGameCOD;
	fGame.fGameSort[25] = kGameFCRY;

	fHotkeys.minimizeActive = true;
	fHotkeys.minimizeId = 0;
	fHotkeys.minimizeRefresh = true;
	fHotkeys.minimizeModifier = MOD_CONTROL;
	fHotkeys.minimizeVirtualKey = 0x51; // Q

	fChanged = 0;
}

void Settings::Load()
{
	int i;
	set<long> leftGames;
	bool sorted[kGameCount + 1];
	int pos;
	set<long>::iterator itGames;

	Init();

	LoadSetting("", "RegistryVersion", fRegVersion);
//	if (fRegVersion < 2)
//		return;

	LoadSetting("Appearance", "WindowMode", fMainWindow.fMode);
	LoadSetting("Appearance", "Left", fMainWindow.fLeft);
	LoadSetting("Appearance", "Top", fMainWindow.fTop);
	LoadSetting("Appearance", "Width", fMainWindow.fWidth);
	LoadSetting("Appearance", "Height", fMainWindow.fHeight);
	LoadSetting("Appearance", "CtlWidth1", fMainWindow.fTVWidth);
	LoadSetting("Appearance", "CtlHeight1", fMainWindow.fLVHeight);
	LoadSetting("Appearance", "CtlWidth2", fMainWindow.fLVWidth);
	LoadSetting("Appearance", "Layout", fMainWindow.fLayout);
	LoadSetting("Appearance", "LayoutParameter1", fMainWindow.fLayoutParameter1);
	LoadSetting("Appearance", "LayoutParameter2", fMainWindow.fLayoutParameter2);
	LoadSetting("Appearance", "MinimizeMode", fMainWindow.fMinimizeMode);
	LoadSetting("Appearance", "ToolBarTextMode", fMainWindow.fToolBarTextMode);

	if (fMainWindow.fLVWidth > fMainWindow.fWidth - fMainWindow.fTVWidth - 5)
		fMainWindow.fLVWidth = fMainWindow.fWidth - fMainWindow.fTVWidth - 20;

	for (i = 0; i < (int) fMainWindow.fServerColumns.size(); i++)
	{
		long len = fMainWindow.fServerColumns[i].fSaveToRegistry;
		LoadSetting("Appearance\\Lists",
					fMainWindow.fServerColumns[i].fID,
					(unsigned char *) &fMainWindow.fServerColumns[i],
					len);
	}
	for (i = 0; i < (int) fMainWindow.fPlayerColumns.size(); i++)
	{
		long len = fMainWindow.fPlayerColumns[i].fSaveToRegistry;
		LoadSetting("Appearance\\Lists",
					fMainWindow.fPlayerColumns[i].fID,
					(unsigned char *) &fMainWindow.fPlayerColumns[i],
					len);
	}
	for (i = 0; i < (int) fMainWindow.fVariableColumns.size(); i++)
	{
		long len = fMainWindow.fVariableColumns[i].fSaveToRegistry;
		LoadSetting("Appearance\\Lists",
					fMainWindow.fVariableColumns[i].fID,
					(unsigned char *) &fMainWindow.fVariableColumns[i],
					len);
	}
	
	LoadSetting("", "StandardGame", fGame.fStandard);
	LoadSetting("", "LastSelectedGame", fGame.fLastSelected);
	for (i = 1; i <= kGameCount; i++)
		sorted[i] = false;
	for (i = 1; i <= kGameCount; i++)
	{
		long len = fGame.fInfos[i].fSaveToRegistry;
		LoadSetting("Games",
					gGames[i].fID + "Info",
					(unsigned char *) &fGame.fInfos[i],
					len);
		LoadSetting("Games",
					gGames[i].fID + "Exe",
					fGame.fInfos[i].fExe);
		LoadSetting("Games",
					gGames[i].fID + "Path",
					fGame.fInfos[i].fPath);
		LoadSetting("Games",
					gGames[i].fID + "Parameters",
					fGame.fInfos[i].fParameters);
		pos = fGame.fInfos[i].fPosition;
		if (pos > 0 && pos <= kGameCount)
		{
			for (int j = 1; j <= kGameCount; j++)
			{
				if (fGame.fGameSort[j] == i)
				{
					fGame.fGameSort[j] = -1;
					sorted[j] = false;
				}
			}
 			leftGames.insert(fGame.fGameSort[pos]);
			fGame.fGameSort[pos] = i;
			leftGames.erase(i);
			sorted[pos] = true;
		}
		else
		{
			leftGames.insert(i);
		}
		long value;
		if (LoadSetting("Hotkeys", "MinimizeActive", value))
			fHotkeys.minimizeActive = value ? true : false;
		if (LoadSetting("Hotkeys", "MinimizeRefresh", value))
			fHotkeys.minimizeRefresh = value ? true : false;
		if (LoadSetting("Hotkeys", "MinimizeModifier", value))
			fHotkeys.minimizeModifier = (unsigned char) value;
		if (LoadSetting("Hotkeys", "MinimizeVirtualKey", value))
			fHotkeys.minimizeVirtualKey = (unsigned char) value;
	}
	for (itGames = leftGames.begin(); itGames != leftGames.end(); itGames++)
	{
		if (*itGames == -1)
			continue;
		for (i = 1; i <= kGameCount; i++)
		{
			if (!sorted[i])
			{
				fGame.fGameSort[i] = *itGames;
				sorted[i] = true;
				break;
			}
		}
	}
	leftGames.clear();

	Check();
}

void Settings::Check()
{
	CheckColumns(fMainWindow.fServerColumns);
	CheckColumns(fMainWindow.fPlayerColumns);
	CheckColumns(fMainWindow.fVariableColumns);
}

void Settings::Save()
{
	int i;
	int game;

	SaveSetting("", "RegistryVersion", fRegVersion);

	SaveSetting("Appearance", "WindowMode", fMainWindow.fMode);
	SaveSetting("Appearance", "Left", fMainWindow.fLeft);
	SaveSetting("Appearance", "Top", fMainWindow.fTop);
	SaveSetting("Appearance", "Width", fMainWindow.fWidth);
	SaveSetting("Appearance", "Height", fMainWindow.fHeight);
	SaveSetting("Appearance", "CtlWidth1", fMainWindow.fTVWidth);
	SaveSetting("Appearance", "CtlHeight1", fMainWindow.fLVHeight);
	SaveSetting("Appearance", "CtlWidth2", fMainWindow.fLVWidth);
	SaveSetting("Appearance", "Layout", fMainWindow.fLayout);
	SaveSetting("Appearance", "LayoutParameter1", fMainWindow.fLayoutParameter1);
	SaveSetting("Appearance", "LayoutParameter2", fMainWindow.fLayoutParameter2);
	SaveSetting("Appearance", "ToolBarTextMode", fMainWindow.fToolBarTextMode);
	SaveSetting("Appearance", "MinimizeMode", fMainWindow.fMinimizeMode);

	for (i = 0; i < (int) fMainWindow.fServerColumns.size(); i++)
	{
		SaveSetting("Appearance\\Lists",
					fMainWindow.fServerColumns[i].fID,
					(unsigned char *) &fMainWindow.fServerColumns[i],
					fMainWindow.fServerColumns[i].fSaveToRegistry);
	}
	for (i = 0; i < (int) fMainWindow.fPlayerColumns.size(); i++)
	{
		SaveSetting("Appearance\\Lists",
					fMainWindow.fPlayerColumns[i].fID,
					(unsigned char *) &fMainWindow.fPlayerColumns[i],
					fMainWindow.fPlayerColumns[i].fSaveToRegistry);
	}
	for (i = 0; i < (int) fMainWindow.fVariableColumns.size(); i++)
	{
		SaveSetting("Appearance\\Lists",
					fMainWindow.fVariableColumns[i].fID,
					(unsigned char *) &fMainWindow.fVariableColumns[i],
					fMainWindow.fVariableColumns[i].fSaveToRegistry);
	}
	
	SaveSetting("", "StandardGame", fGame.fStandard);
	SaveSetting("", "LastSelectedGame", fGame.fLastSelected);
	for (i = 1; i <= kGameCount; i++)
	{
		game = fGame.fGameSort[i];
		fGame.fInfos[game].fPosition = i;
		SaveSetting("Games",
					gGames[game].fID + "Info",
					(unsigned char *) &fGame.fInfos[game],
					fGame.fInfos[game].fSaveToRegistry);
		SaveSetting("Games",
					gGames[game].fID + "Exe",
					fGame.fInfos[game].fExe);
		SaveSetting("Games",
					gGames[game].fID + "Path",
					fGame.fInfos[game].fPath);
		SaveSetting("Games",
					gGames[game].fID + "Parameters",
					fGame.fInfos[game].fParameters);
	}
	SaveSetting("Hotkeys", "MinimizeActive", fHotkeys.minimizeActive);
	SaveSetting("Hotkeys", "MinimizeRefresh", fHotkeys.minimizeRefresh);
	SaveSetting("Hotkeys", "MinimizeModifier", fHotkeys.minimizeModifier);
	SaveSetting("Hotkeys", "MinimizeVirtualKey", fHotkeys.minimizeVirtualKey);
}

Settings& Settings::operator=(Settings& other)
{
	int i;

	fRegVersion = other.fRegVersion;

	fMainWindow.fMode = other.fMainWindow.fMode;
	fMainWindow.fLeft = other.fMainWindow.fLeft;
	fMainWindow.fTop = other.fMainWindow.fTop;
	fMainWindow.fWidth = other.fMainWindow.fWidth;
	fMainWindow.fHeight = other.fMainWindow.fHeight;
	fMainWindow.fTVWidth = other.fMainWindow.fTVWidth;
	fMainWindow.fLVHeight = other.fMainWindow.fLVHeight;
	fMainWindow.fLVWidth = other.fMainWindow.fLVWidth;
	fMainWindow.fLayout = other.fMainWindow.fLayout;
	fMainWindow.fLayoutParameter1 = other.fMainWindow.fLayoutParameter1;
	fMainWindow.fLayoutParameter2 = other.fMainWindow.fLayoutParameter2;
	fMainWindow.fMinimizeMode = other.fMainWindow.fMinimizeMode;
	fMainWindow.fToolBarTextMode = other.fMainWindow.fToolBarTextMode;
	fMainWindow.fServerColumns.clear();
	for (i = 0; i < (int) other.fMainWindow.fServerColumns.size(); i++)
	{
		fMainWindow.fServerColumns.push_back(other.fMainWindow.fServerColumns[i]);
	}
	fMainWindow.fPlayerColumns.clear();
	for (i = 0; i < (int) other.fMainWindow.fPlayerColumns.size(); i++)
	{
		fMainWindow.fPlayerColumns.push_back(other.fMainWindow.fPlayerColumns[i]);
	}
	fMainWindow.fVariableColumns.clear();
	for (i = 0; i < (int) other.fMainWindow.fVariableColumns.size(); i++)
	{
		fMainWindow.fVariableColumns.push_back(other.fMainWindow.fVariableColumns[i]);
	}

	fGame.fStandard = other.fGame.fStandard;
	fGame.fLastSelected = other.fGame.fLastSelected;
	for (i = 0; i <= kGameCount; i++)
		fGame.fGameSort[i] = other.fGame.fGameSort[i];
	fGame.fInfos.clear();
	for (i = 0; i < (int) other.fGame.fInfos.size(); i++)
	{
		fGame.fInfos.push_back(other.fGame.fInfos[i]);
	}

	fHotkeys.minimizeActive = other.fHotkeys.minimizeActive;
	fHotkeys.minimizeId = other.fHotkeys.minimizeId;
	fHotkeys.minimizeRefresh = other.fHotkeys.minimizeRefresh;
	fHotkeys.minimizeModifier = other.fHotkeys.minimizeModifier;
	fHotkeys.minimizeVirtualKey = other.fHotkeys.minimizeVirtualKey;

	fChanged = other.fChanged;

	return *this;
}

void Settings::SetChanged(Settings& old)
{
	int i;

	fChanged = 0;

	if (fMainWindow.fLayout != old.fMainWindow.fLayout ||
		fMainWindow.fLayoutParameter1 != old.fMainWindow.fLayoutParameter1 ||
		fMainWindow.fLayoutParameter2 != old.fMainWindow.fLayoutParameter1)
		fChanged |= kChangedLayout;
	if (fMainWindow.fToolBarTextMode != old.fMainWindow.fToolBarTextMode)
		fChanged |= kChangedToolBar;
	for (i = 0; i < (int) fMainWindow.fServerColumns.size(); i++)
		if (fMainWindow.fServerColumns[i].fPosition != old.fMainWindow.fServerColumns[i].fPosition)
		{
			fChanged |= kChangedServerList;
			break;
		}
	for (i = 0; i < (int) fMainWindow.fPlayerColumns.size(); i++)
		if (fMainWindow.fPlayerColumns[i].fPosition != old.fMainWindow.fPlayerColumns[i].fPosition)
		{
			fChanged |= kChangedPlayerList;
			break;
		}
	for (i = 0; i < (int) fMainWindow.fVariableColumns.size(); i++)
		if (fMainWindow.fVariableColumns[i].fPosition != old.fMainWindow.fVariableColumns[i].fPosition)
		{
			fChanged |= kChangedVariableList;
			break;
		}
	for (i = 1; i <= kGameCount; i++)
		if (fGame.fGameSort[i] != old.fGame.fGameSort[i])
		{
			fChanged |= kChangedGameList;
			break;
		}
}

void Settings::CheckColumns(vector<COLUMNINFO> &columns)
{
	vector<COLUMNINFO> visible;
	COLUMNINFO column;
	int i;
	int j;

	for (i = 0; i < (int) columns.size(); i++)
	{
		if (columns[i].fVisible)
			visible.push_back(columns[i]);
		else
			columns[i].fPosition = -1;
	}
	for (i = 1; i < (int) visible.size(); i++)
		for (j = i - 1; j >= 0; j--)
			if (visible[j + 1].fPosition < visible[j].fPosition)
			{
				column = visible[j];
				visible[j] = visible[j + 1];
				visible[j + 1] = column;
			}
			else
				break;
	for (i = 0; i < (int) visible.size(); i++)
	{
		visible[i].fPosition = i;
		for (j = 0; j < (int) columns.size(); j++)
		{
			if (columns[j].fID == visible[i].fID)
			{
				columns[j].fPosition = visible[i].fPosition;
				break;
			}
		}
	}
}

bool Settings::LoadSetting(string folder, string name, string &value)
{
	HKEY key;
	string str = "Software\\QFinder2\\" + folder;
	unsigned long type;
	unsigned char buffer[1000];
	unsigned long size = 1000;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, str.c_str(), 0, "", 0, KEY_ALL_ACCESS, NULL, &key, NULL) == ERROR_SUCCESS)
	{
		if (RegQueryValueEx(key, name.c_str(), 0, &type, buffer, &size) == ERROR_SUCCESS)
		{
			if (type == REG_SZ)
			{
				value = (char *) buffer;
				return true;
			}
		}
	}
	return false;
}

bool Settings::LoadSetting(string folder, string name, long &value)
{
	HKEY key;
	string str = "Software\\QFinder2\\" + folder;
	unsigned long type;
	unsigned long buffer;
	unsigned long size = 4;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, str.c_str(), 0, "", 0, KEY_ALL_ACCESS, NULL, &key, NULL) == ERROR_SUCCESS)
	{
		if (RegQueryValueEx(key, name.c_str(), 0, &type, (BYTE *) &buffer, &size) == ERROR_SUCCESS)
		{
			if (type == REG_DWORD)
			{
				value = buffer;
				return true;
			}
		}
	}
	return false;
}

bool Settings::LoadSetting(string folder, string name, unsigned char *value, long &length)
{
	HKEY key;
	string str = "Software\\QFinder2\\" + folder;
	unsigned long type;
	unsigned char buffer[1000];
	unsigned long size = length;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, str.c_str(), 0, "", 0, KEY_ALL_ACCESS, NULL, &key, NULL) == ERROR_SUCCESS)
	{
		if (RegQueryValueEx(key, name.c_str(), 0, &type, buffer, &size) == ERROR_SUCCESS)
		{
			if (type == REG_BINARY)
			{
				memcpy(value, buffer, size);
				length = size;
				return true;
			}
		}
	}
	return false;
}

void Settings::SaveSetting(string folder, string name, string value)
{
	HKEY key;
	string str = "Software\\QFinder2\\" + folder;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, str.c_str(), 0, "", 0, KEY_ALL_ACCESS, NULL, &key, NULL) == ERROR_SUCCESS)
	{
		if (RegSetValueEx(key, name.c_str(), 0, REG_SZ, (BYTE *) value.c_str(), value.length() + 1) == ERROR_SUCCESS)
		{
		}
	}
}

void Settings::SaveSetting(string folder, string name, long value)
{
	HKEY key;
	string str = "Software\\QFinder2\\" + folder;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, str.c_str(), 0, "", 0, KEY_ALL_ACCESS, NULL, &key, NULL) == ERROR_SUCCESS)
	{
		if (RegSetValueEx(key, name.c_str(), 0, REG_DWORD, (BYTE *) &value, 4) == ERROR_SUCCESS)
		{
		}
	}
}

void Settings::SaveSetting(string folder, string name, unsigned char *value, long length)
{
	HKEY key;
	string str = "Software\\QFinder2\\" + folder;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, str.c_str(), 0, "", 0, KEY_ALL_ACCESS, NULL, &key, NULL) == ERROR_SUCCESS)
	{
		if (RegSetValueEx(key, name.c_str(), 0, REG_BINARY, value, length) == ERROR_SUCCESS)
		{
		}
	}
}
