/*
 * QFinder - A game server browser for Windows
 *
 * Copyright (C) 1999,2004 Andreas Regel <andreas.regel@powarman.de>
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 */

#ifndef _SOCKETWINDOW_H_
#define _SOCKETWINDOW_H_

#include <vector>
#include <winsock.h>

static const int kMsgNetwork = WM_USER + 10;

class MainWindow;

struct SOCKETEVENT
{
	SOCKET fSocket;
	long fEvent;
	int fMessage;
	long fStartTicks;
};

class SocketWindow
{
public:
	SocketWindow(MainWindow *mainWnd);
	~SocketWindow();
	LRESULT WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	void AddSocketEvent(SOCKET newSocket, long event, int message);
	void RemoveSocketEvent(SOCKET existingSocket);
private:
	HWND fWindow;
	vector<struct SOCKETEVENT> fSockets;

	MainWindow *fMainWnd;
};

LRESULT APIENTRY SocketWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

extern SocketWindow *gSocketWindow;

#endif //_SOCKETWINDOW_H_